Index: palm/trunk/DOC/app/chapter_3.9.html
===================================================================
--- palm/trunk/DOC/app/chapter_3.9.html	(revision 219)
+++ palm/trunk/DOC/app/chapter_3.9.html	(revision 220)
@@ -47,9 +47,8 @@
 averaged mean profiles as provided with the standard PALM output are
 used. The user has to set parameters <a href="chapter_4.2.html#dt_data_output_pr">dt_data_output_pr</a>, <a href="chapter_4.2.html#averaging_interval">averaging_interval</a>,
-etc. for the precursor run appropriately, so that an output is done at
-the end of the precursor run. The profile information is then contained
+etc. for the precursor run appropriately, so that an output is done <span style="font-weight: bold;">at
+the end</span> of the precursor run. The profile information is then contained
 in the restart (binary) file created at the end of the precursor run
-and can be used by the main run. <span style="font-weight: bold;">It is very important that the mean profiles at the end of the precursor run are in a stationary or quasi-stationary state</span>, because otherwise it may not be justified to use them as constant profiles at the inflow. <span style="font-weight: bold;">Also, turbulence at the end of the precursor run should be fully developed. </span>Otherwise, the main run would need an additional spinup-time at the beginning to get the turbulence to its final stage.<br></li><li>The
-main run has to read the binary data from the precursor run .... &nbsp;
+and can be used by the main run. <span style="font-weight: bold;">It is very important that the mean profiles at the end of the precursor run are in a stationary or quasi-stationary state</span>, because otherwise it may not be justified to use them as constant profiles at the inflow. <span style="font-weight: bold;">Also, turbulence at the end of the precursor run should be fully developed. </span>Otherwise, the main run would need an additional spinup-time at the beginning to get the turbulence to its final stage.<br></li><li>In order to read the binary data from the precursor run, parameter <a href="chapter_4.1.html#initializing_actions">initializing_actions</a> = <span style="font-style: italic;">'read_data_for_recycling'</span> has to be set in the main run. &nbsp; .... &nbsp;
 &nbsp; set bc_lr = 'dirichlet/radiation' ... &nbsp;
 conserve_volume_flow = .TRUE. ? ....</li><li>The main run allows to use a larger domain along x and y than in the precursor run ...</li><li>Recycling width should be equal to the domain size of the precursor run (or larger?)</li></ul><pre style="line-height: 100%;"><font style="font-size: 10pt;" size="2">#</font><br><font style="font-size: 10pt;" size="2">RUN_CONTROL<span style="font-weight: bold;">_O</span></font><font style="font-size: 10pt;" size="2"> out:loc:tr d3<span style="font-weight: bold;">o</span># ~/palm/current_version/JOBS/$fname/MONITORING <span style="font-weight: bold;">_</span></font><font style="font-size: 10pt;" size="2"><span style="font-weight: bold;">o</span>_</font><font style="font-size: 10pt;" size="2">rc</font><br><font style="font-size: 10pt;" size="2">HEADER</font><font style="font-size: 10pt;" size="2"><span style="font-weight: bold;">_O</span> out:loc:tr d3<span style="font-weight: bold;">o</span># ~/palm/current_version/JOBS/$fname/MONITORING <span style="font-weight: bold;">_</span></font><font style="font-size: 10pt;" size="2"><span style="font-weight: bold;">o</span>_</font><font style="font-size: 10pt;" size="2">header</font><br><font style="font-size: 10pt;" size="2">PLOT1D_PAR<span style="font-weight: bold;">_O</span></font><font style="font-size: 10pt;" size="2"> out:loc:tr pr<span style="font-weight: bold;">o</span># ~/palm/current_version/JOBS/$fname/OUTPUT <span style="font-weight: bold;">_</span></font><font style="font-size: 10pt;" size="2"><span style="font-weight: bold;">o</span>_</font><font style="font-size: 10pt;" size="2">pr_par</font><br><font style="font-size: 10pt;" size="2">PLOT1D_DATA</font><font style="font-size: 10pt;" size="2"><span style="font-weight: bold;">_O</span> out:loc:tr pr<span style="font-weight: bold;">o</span># ~/palm/current_version/JOBS/$fname/OUTPUT <span style="font-weight: bold;">_</span></font><font style="font-size: 10pt;" size="2"><span style="font-weight: bold;">o</span>_</font><font style="font-size: 10pt;" size="2">pr_in</font><br></pre><br><hr>
Index: palm/trunk/SCRIPTS/mrun
===================================================================
--- palm/trunk/SCRIPTS/mrun	(revision 219)
+++ palm/trunk/SCRIPTS/mrun	(revision 220)
@@ -1896,5 +1896,5 @@
  then
 
-    printf "\n  +++ no compiler specified for \"$localhost $cond1 $cond2\""
+    printf "\n  +++ no compiler specified for \"$host $cond1 $cond2\""
     locat=compiler_name; exit
 
@@ -2375,5 +2375,5 @@
        elif [[ $localhost = lcsgih ]]
        then
-          printf "      compiler is called via ssh on \"hicegate\" \n"
+          printf "      compiler is called via ssh on \"hicegate2\" \n"
           ssh  130.75.4.103  -l $usern  ". /usr/share/modules/init/bash; module load mpt; cd $TEMPDIR; make -f Makefile PROG=a.out  F90=$compiler_name  COPT=\"$cpp_options\"  F90FLAGS=\"$fopts\"  LDFLAGS=\"$lopts\" 2>&1 "
 #          ssh  130.75.4.102  -l $usern  ". /usr/share/modules/init/bash; module load mvapich2; cd $TEMPDIR; make -f Makefile PROG=a.out  F90=$compiler_name  COPT=\"$cpp_options\"  F90FLAGS=\"$fopts\"  LDFLAGS=\"$lopts\" 2>&1 "
Index: palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- palm/trunk/SOURCE/flow_statistics.f90	(revision 219)
+++ palm/trunk/SOURCE/flow_statistics.f90	(revision 220)
@@ -1008,5 +1008,5 @@
        ts_value(19,sr) = hom(nzb+1,1,pr_palm,sr)    ! u'w'    at k=0
        ts_value(20,sr) = hom(nzb+2,1,pr_palm,sr)    ! v'w'    at k=0
-       ts_value(21,sr) = hom(nzb+12,1,pr_palm,sr)   ! w'q'    at k=0
+       ts_value(21,sr) = hom(nzb+12,1,pr_palm,sr)   ! q*
 
        IF ( ts_value(5,sr) /= 0.0 )  THEN
Index: palm/trunk/SOURCE/read_3d_binary.f90
===================================================================
--- palm/trunk/SOURCE/read_3d_binary.f90	(revision 219)
+++ palm/trunk/SOURCE/read_3d_binary.f90	(revision 220)
@@ -974,7 +974,7 @@
 !
 !--    Read user-defined restart data
-       CALL user_read_restart_data( nxlfa, nxl_on_file, nxrfa, nxr_on_file, &
-                                    nynfa, nyn_on_file, nysfa, nys_on_file, &
-                                    offset_xa, offset_ya, overlap_count(i), &
+       CALL user_read_restart_data( i, nxlfa, nxl_on_file, nxrfa, nxr_on_file, &
+                                    nynfa, nyn_on_file, nysfa, nys_on_file,    &
+                                    offset_xa, offset_ya, overlap_count(i),    &
                                     tmp_2d, tmp_3d )
 
Index: palm/trunk/SOURCE/user_module.f90
===================================================================
--- palm/trunk/SOURCE/user_module.f90	(revision 219)
+++ palm/trunk/SOURCE/user_module.f90	(revision 220)
@@ -37,5 +37,5 @@
     INTEGER ::  dots_num_palm, user_idummy
     LOGICAL ::  user_defined_namelist_found = .FALSE.
-    REAL    ::  user_dummy
+    REAL    ::  user_rdummy
 
 !
Index: palm/trunk/SOURCE/user_read_restart_data.f90
===================================================================
--- palm/trunk/SOURCE/user_read_restart_data.f90	(revision 219)
+++ palm/trunk/SOURCE/user_read_restart_data.f90	(revision 220)
@@ -1,5 +1,5 @@
- SUBROUTINE user_read_restart_data( nxlfa, nxl_on_file, nxrfa, nxr_on_file, &
-                                    nynfa, nyn_on_file, nysfa, nys_on_file, &
-                                    offset_xa, offset_ya, overlap_count,    &
+ SUBROUTINE user_read_restart_data( i, nxlfa, nxl_on_file, nxrfa, nxr_on_file, &
+                                    nynfa, nyn_on_file, nysfa, nys_on_file,    &
+                                    offset_xa, offset_ya, overlap_count,       &
                                     tmp_2d, tmp_3d )
 
@@ -33,5 +33,5 @@
     CHARACTER (LEN=20) :: field_char
 
-    INTEGER ::  k, nxlc, nxlf, nxl_on_file, nxrc, nxrf, nxr_on_file, nync, &
+    INTEGER ::  i, k, nxlc, nxlf, nxl_on_file, nxrc, nxrf, nxr_on_file, nync, &
                 nynf, nyn_on_file, nysc, nysf, nys_on_file, overlap_count
 