Index: /palm/trunk/SOURCE/CURRENT_MODIFICATIONS
===================================================================
--- /palm/trunk/SOURCE/CURRENT_MODIFICATIONS	(revision 224)
+++ /palm/trunk/SOURCE/CURRENT_MODIFICATIONS	(revision 225)
@@ -25,4 +25,8 @@
 User interface has been split into single files.
 
+Type of count and count_rate changed to INTEGER(8) in order to avoid out of
+range problems, which result in measured negative time intervals. (cpu_log,
+local_tremain, local_tremain_ini)
+
 Reading mechanism from restart files completely revised. The subdomain/total
 domain size can vary arbitrarily between current and previous run.
@@ -49,5 +53,5 @@
 (init_grid, modules, user_header, user_init_grid, user_parin)
 
-Makefile, mbuild, mrun, advec_s_bc, check_parameters, local_stop, modules, netcdf, read_var_list, read_3d_binary, user_read_restart_data
+Makefile, mbuild, mrun, advec_s_bc, check_parameters, cpu_log, local_stop, local_tremain, local_tremain_ini, modules, netcdf, read_var_list, read_3d_binary, user_read_restart_data
 
 New: handle_palm_message, user_3d_data_averaging user_actions user_advec_particles user_check_data_output user_check_data_output_pr user_data_output_2d user_data_output_3d user_data_output_dvrp user_define_netcdf_grid user_dvrp_coltab user_header user_init user_init_3d_model user_init_grid user_init_particles user_init_plant_canopy user_last_actions user_module user_parin user_particle_attributes user_read_restart_data user_spectra user_statistics
@@ -58,4 +62,6 @@
 Errors:
 ------
+
+Bugfix: array d is reallocated in case that multigrid is used (calc_spectra)
 
 Bugfixes for nonparallel execution (check_for_restart, cpu_statistics, inflow_turbulence, init_coupling, timestep)
@@ -82,3 +88,3 @@
 Bugfix: abort in case that absolute temperature is below zero (init_cloud_physics)
 
-advec_particles, check_for_restart, combine_plot_fields, cpu_statistics, data_output_2d, header, inflow_turbulence, init_cloud_physics, init_coupling, production_e, read_3d_binary, timestep
+advec_particles, calc_spectra, check_for_restart, combine_plot_fields, cpu_statistics, data_output_2d, header, inflow_turbulence, init_cloud_physics, init_coupling, production_e, read_3d_binary, timestep
Index: /palm/trunk/SOURCE/calc_spectra.f90
===================================================================
--- /palm/trunk/SOURCE/calc_spectra.f90	(revision 224)
+++ /palm/trunk/SOURCE/calc_spectra.f90	(revision 225)
@@ -4,5 +4,5 @@
 ! Actual revisions:
 ! -----------------
-! 
+! Bugfix: array d is reallocated in case that multigrid is used
 !
 ! Former revisions:
@@ -55,4 +55,11 @@
 !-- Initialize ffts
     CALL fft_init
+
+!
+!-- Reallocate array d in required size
+    IF ( psolver == 'multigrid' )  THEN
+       DEALLOCATE( d )
+       ALLOCATE( d(nzb+1:nzta,nys:nyna,nxl:nxra) )
+    ENDIF
 
 !
Index: /palm/trunk/SOURCE/cpu_log.f90
===================================================================
--- /palm/trunk/SOURCE/cpu_log.f90	(revision 224)
+++ /palm/trunk/SOURCE/cpu_log.f90	(revision 225)
@@ -4,5 +4,5 @@
 ! Actual revisions:
 ! -----------------
-! 
+! Type of count and count_rate changed to INTEGER(8)
 !
 ! Former revisions:
@@ -40,5 +40,5 @@
 
 #if defined( __lc ) || defined( __decalpha ) || defined( __nec )
-    INTEGER                     ::  count, count_rate
+    INTEGER(8)                  ::  count, count_rate
 #elif defined( __ibm )
     INTEGER(8)                  ::  IRTC
Index: /palm/trunk/SOURCE/local_tremain.f90
===================================================================
--- /palm/trunk/SOURCE/local_tremain.f90	(revision 224)
+++ /palm/trunk/SOURCE/local_tremain.f90	(revision 225)
@@ -4,5 +4,6 @@
 ! Actual revisions:
 ! -----------------
-! 
+! Type of count and count_rate changed to INTEGER(8) in order to avoid out of
+! range problems (which result in measured negative time intervals)
 !
 ! Former revisions:
@@ -39,5 +40,5 @@
     REAL       ::  actual_wallclock_time
 #elif defined( __lc )
-    INTEGER    ::  count, count_rate
+    INTEGER(8) ::  count, count_rate
     REAL       ::  actual_wallclock_time
 #endif
Index: /palm/trunk/SOURCE/local_tremain_ini.f90
===================================================================
--- /palm/trunk/SOURCE/local_tremain_ini.f90	(revision 224)
+++ /palm/trunk/SOURCE/local_tremain_ini.f90	(revision 225)
@@ -4,5 +4,6 @@
 ! Actual revisions:
 ! -----------------
-! 
+! Type of count and count_rate changed to INTEGER(8) in order to avoid out of
+! range problems (which result in measured negative time intervals)
 !
 ! Former revisions:
@@ -40,5 +41,5 @@
     CHARACTER (LEN=10) ::  value_chr
     INTEGER            ::  idum
-    INTEGER            ::  count, count_rate
+    INTEGER(8)         ::  count, count_rate
 #endif
 