Index: palm/trunk/DOC/tec/technical_documentation.html
===================================================================
--- palm/trunk/DOC/tec/technical_documentation.html	(revision 198)
+++ palm/trunk/DOC/tec/technical_documentation.html	(revision 226)
@@ -12,5 +12,5 @@
 <br><table nosave="" cellpadding="0" cellspacing="0"> <caption>&nbsp; <br> </caption><tbody>
 </tbody><tbody> </tbody> <tbody> <tr nosave=""> <td nosave=""><b>Current
-model version:</b></td> <td><span style="font-weight: bold;">3.5</span></td> </tr>
+model version:</b></td> <td><span style="font-weight: bold;">3.6</span></td> </tr>
 <tr nosave=""> <td nosave=""><b>Last
 change of this document</b>:&nbsp;</td> <td nosave=""><b>$Id$</b></td> </tr>
@@ -2434,5 +2434,40 @@
 init_3d_model, init_dvrp, local_stop, plant_canopy_model, poismg,
 prandtl_fluxes, pres, read_3d_binary, user_interface, wall_fluxes,
-write_3d_binary<br></td></tr>
+write_3d_binary<br></td></tr><tr><td style="vertical-align: top;">02/02/09</td><td style="vertical-align: top;">SR</td><td style="vertical-align: top;">3.6</td><td style="vertical-align: top;">N</td><td style="vertical-align: top;">This
+release contains further additions, changes, and bugfixes for the
+SGI-ICE system, as well as important changes like the splitting of the
+user-interface into single files, a complete revision of the
+pre-compiling mechanism allowing to use different make-depositories
+simultaneously, and a revision of the reading-mechanism from restart
+files, which has no more restrictions in case that the previous and
+current run have different domain/subdomain sizes. A new handling of
+all kind of output messages is introduced with this release and will be
+applied to all existing messages within the next releases.<br><br><span style="font-weight: bold;">New features are:</span><br style="font-weight: bold;"><br>Restart runs on SGI-ICE are working. (mrun)<br>2d-decomposition is default on SGI-ICE systems. (init_pegrid)<br><br>Ocean-atmosphere coupling realized with MPI-1. mrun adjusted for this case (-Y option). Check that PALM is called with <span style="font-family: Courier New,Courier,monospace;">mrun</span>-option "<span style="font-style: italic;">-K parallel</span>" for coupling. Adjustments in <span style="font-family: Courier New,Courier,monospace;">mrun</span>, <span style="font-family: Courier New,Courier,monospace;">mbuild</span>, and <span style="font-family: Courier New,Courier,monospace;">subjob</span> for lcxt4.<br><br>DVRP arguments changed to single precision, mode pathlines added.<br><br>User can add additional routines in files <span style="font-family: Courier New,Courier,monospace;">user_additional_routines</span>.<br><br>User can check user parameters and deduce further quantities in <span style="font-family: Courier New,Courier,monospace;">user_check_parameters</span>.</td><td style="vertical-align: top;">check_for_restart,
+check_parameters, data_output_dvrp, init_dvrp, init_pegrid, local_stop,
+modules, package_parin, palm, surface_coupler, timestep<br><br>Makefile,&nbsp;mbuild, mrun, subjob<br><br><span style="font-weight: bold;">new:</span><br>init_coupling, user_additional_routines, user_check_parameters</td></tr><tr><td style="vertical-align: top;">&nbsp;</td><td style="vertical-align: top;">&nbsp;</td><td style="vertical-align: top;">&nbsp;</td><td style="vertical-align: top;">C</td><td style="vertical-align: top;">&nbsp;User interface has been split into single files.<br><br>Type of variables <span style="font-family: Courier New,Courier,monospace;">count</span> and <span style="font-family: Courier New,Courier,monospace;">count_rate</span>
+changed to INTEGER(8) in order to avoid "out of range" problems, which
+result in measured negative time intervals. (cpu_log, local_tremain,
+local_tremain_ini)<br><br>Reading mechanism from restart files
+completely revised. The subdomain/total domain size is now allowed to
+vary arbitrarily between the current and previous run. (read_var_list,
+read_3d_binary, user_read_restart_data)<br><br>Precompilation mechanism (<span style="font-family: Courier New,Courier,monospace;">mbuild</span>) completely revised: the source-tarfile remains in the source directory (<span style="font-family: Courier New,Courier,monospace;">trunk/SOURCE</span>).
+One depository per block (given in the config-file) is created. Always
+all files from the source directory are copied to the respective
+depository. No additional file checks are done any more (mrun version
+2.1). The depository name used contains the conditions given by <span style="font-family: Courier New,Courier,monospace;">mrun</span>-option "<span style="font-family: Courier New,Courier,monospace;">-K</span>". (mbuild, mrun)<br><br>Output messages (including required stop of execution) can now be handled with the new subroutine&nbsp;<span style="font-family: Courier New,Courier,monospace;">message</span>. All output messages will be replaced by this routine step by step within the next revisions.<br><br>Neumann boundary condition at <span style="font-family: Courier New,Courier,monospace;">k=nzb</span> is explicitly set for better reading, although this has been already done in boundary_conds. (advec_s_bc)<br><br>Origin of the xy-coordinate system shifted from the center of the first grid cell (indices <span style="font-family: Courier New,Courier,monospace;">i=0</span>, <span style="font-family: Courier New,Courier,monospace;">j=0</span>) to the south-left corner of this cell. (netcdf) Topography definition according to new user parameter <span style="font-family: Courier New,Courier,monospace;">topography_grid_convention</span>. (init_grid, modules, user_header, user_init_grid, user_parin)</td><td style="vertical-align: top;">advec_s_bc,
+check_parameters, cpu_log, init_grid, local_stop, local_tremain,
+local_tremain_ini, modules, netcdf, read_3d_binary, read_var_list,
+user_read_restart_data<br><br>Makefile, mbuild, mrun<br><br><span style="font-weight: bold;">removed:</span><br>user_interface<br><br><span style="font-weight: bold;">new:</span><br>message,
+user_3d_data_averaging, user_actions, user_advec_particles,
+user_check_data_output, user_check_data_output_pr, user_data_output_2d,
+user_data_output_3d, user_data_output_dvrp, user_define_netcdf_grid,
+user_dvrp_coltab, user_header, user_init_3d_model, user_init,
+user_init_grid, user_init_particles, user_init_plant_canopy, user_last_actions, user_parin, user_parin, user_particle_attributes, user_read_restart_data, user_spectra, user_statistics</td></tr><tr><td style="vertical-align: top;">&nbsp;</td><td style="vertical-align: top;">&nbsp;</td><td style="vertical-align: top;">&nbsp;</td><td style="vertical-align: top;">E</td><td style="vertical-align: top;">&nbsp;Bugfix: array <span style="font-family: Courier New,Courier,monospace;">d</span> is reallocated in case that multigrid is used. (calc_spectra)<br><br>Bugfixes for nonparallel execution. (check_for_restart, cpu_statistics, inflow_turbulence,&nbsp;timestep)<br><br>Size of <span style="font-family: Courier New,Courier,monospace;">pf3d </span>adjusted to the required output size (1 gridpoint less, along all three dimensions), because output of a subset of the data (<span style="font-family: Courier New,Courier,monospace;">pf3d(nxa:nxe...)</span>) in the NF90_PUT_VAR statement caused segmentation fault with the INTEL compiler. (combine_plot_fields)<br><br>Bugfix: error in <span style="font-family: Courier New,Courier,monospace;">zu</span> index in case of <span style="font-family: Courier New,Courier,monospace;">section_xy=-1</span>. (header)<br><br>Inconsistency
+removed: as the thermal stratification is not taken into account for
+the evaluation of the wall fluxes at vertical walls, the eddy viscosity
+<span style="font-family: Courier New,Courier,monospace;">km</span> must not be used for the evaluation of the velocity gradients <span style="font-family: Courier New,Courier,monospace;">dudy</span>, <span style="font-family: Courier New,Courier,monospace;">dwdy</span>, <span style="font-family: Courier New,Courier,monospace;">dvdx</span> and <span style="font-family: Courier New,Courier,monospace;">dwdx</span>. (production_e)<br><br>Bugfix in calculating <span style="font-family: Courier New,Courier,monospace;">k</span> index in case of oceans runs. (sort_particles)<br><br>Bugfix: no output of particle concentration and radius unless particles have been started. (data_output_2d)<br><br>Bugfix: reading of <span style="font-family: Courier New,Courier,monospace;">spectrum_x|y</span> from restart files ignored if total numbers of grid points do not match. (read_3d_binary)<br><br>Bugfix: abort in case that absolute temperature is below zero. (init_cloud_physics)</td><td style="vertical-align: top;">advec_particles,
+calc_spectra, check_for_restart, cpu_statistics, data_output_2d,
+header, inflow_turbulence, init_cloud_physics, production_e,
+read_3d_binary, timestep<br><br>combine_plot_fields</td></tr>
 </tbody>
 </table>&nbsp;<b><blink>Attention:</blink></b>