Index: palm/trunk/SOURCE/CURRENT_MODIFICATIONS
===================================================================
--- palm/trunk/SOURCE/CURRENT_MODIFICATIONS	(revision 226)
+++ palm/trunk/SOURCE/CURRENT_MODIFICATIONS	(revision 227)
@@ -1,61 +1,8 @@
 New:
 ---
-Restart runs on SGI-ICE are working (mrun).
-2d-decomposition is default on SGI-ICE systems. (init_pegrid)
-
-Ocean-atmosphere coupling realized with MPI-1. mrun adjusted for this case
-(-Y option). Adjustments in mrun, mbuild, and subjob for lcxt4.
-
-DVRP arguments changed to single precision, mode pathlines added.
-
-User can add additional routines in files user_additional_routines
-
-User can check user parameters and deduce further quantities in user_check_parameters
-
-Check that PALM is called with mrun -K parallel for coupling
-
-check_for_restart, check_parameters, data_output_dvrp, init_dvrp, init_pegrid, local_stop, modules, package_parin, palm, surface_coupler, timestep, user_additional_routines
-Makefile, mrun, mbuild, subjob
-
-New: init_coupling, user_check_parameters
 
 
 Changed:
 -------
-User interface has been split into single files.
-
-Type of count and count_rate changed to INTEGER(8) in order to avoid out of
-range problems, which result in measured negative time intervals. (cpu_log,
-local_tremain, local_tremain_ini)
-
-Reading mechanism from restart files completely revised. The subdomain/total
-domain size can vary arbitrarily between current and previous run.
-(read_var_list, read_3d_binary, user_read_restart_data)
-
-Precompilation mechanism (mbuild) completely revised: the source tarfile remains in
-the source directory. One depository per block (given in the config-file) is
-created. Always all files from the source directory are copied to the respective
-depository. No additional file checks are done any more (version 2.1). The
-depository name used contains the conditions given by mrun-option "-K".
-(mbuild, mrun)
-
-Output messages (including required stop of execution) can now be handled with
-the new subroutine handle_palm_message. All output messages will be replaced
-by this routine step by step within the next revisions.
-
-Neumann boundary condition at k=nzb is explicitly set for better reading,
-although this has been already done in boundary_conds. (advec_s_bc)
-
-Origin of the xy-coordinate system shifted from the center of the first
-grid cell (indices i=0, j=0) to the south-left corner of this cell. (netcdf)
-
-Topography definition according to new user parameter topography_grid_convention
-(init_grid, modules, user_header, user_init_grid, user_parin)
-
-Makefile, mbuild, mrun, advec_s_bc, check_parameters, cpu_log, local_stop, local_tremain, local_tremain_ini, modules, netcdf, read_var_list, read_3d_binary, user_read_restart_data
-
-New: handle_palm_message, user_3d_data_averaging user_actions user_advec_particles user_check_data_output user_check_data_output_pr user_data_output_2d user_data_output_3d user_data_output_dvrp user_define_netcdf_grid user_dvrp_coltab user_header user_init user_init_3d_model user_init_grid user_init_particles user_init_plant_canopy user_last_actions user_module user_parin user_particle_attributes user_read_restart_data user_spectra user_statistics
-
-Removed: user_interface
 
 
@@ -63,28 +10,2 @@
 ------
 
-Bugfix: array d is reallocated in case that multigrid is used (calc_spectra)
-
-Bugfixes for nonparallel execution (check_for_restart, cpu_statistics, inflow_turbulence, init_coupling, timestep)
-
-Size of pf3d adjusted to the required output size (1 gridpoint less, along
-all three dimensions), because output of a subset of the data
-(pf3d(nxa:nxe...) in the NF90_PUT_VAR statement caused segmentation fault
-with the INTEL compiler. (combine_plot_fields)
-
-Bugfix: error in zu index in case of section_xy = -1 (header)
-
-Inconsistency removed: as the thermal stratification is not taken into account for the evaluation of the wall 
-fluxes at vertical walls, the eddy viscosity km must not be used for the evaluation of the velocity gradients dudy, 
-dwdy, dvdx and dwdx. (production_e)
-
-Bugfix in calculating k index in case of oceans runs. (sort_particles)
-
-Bugfix: zero output of particle concentration and radius unless particles
-have been started (data_output_2d)
-
-Bugfix: reading of spectrum_x|y from restart files ignored if total numbers
-of grid points do not match (read_3d_binary)
-
-Bugfix: abort in case that absolute temperature is below zero (init_cloud_physics)
-
-advec_particles, calc_spectra, check_for_restart, combine_plot_fields, cpu_statistics, data_output_2d, header, inflow_turbulence, init_cloud_physics, init_coupling, production_e, read_3d_binary, timestep